#!/bin/bash
set -ex

# see man flock "EXAMPLES"
[ "${FLOCKER}" != "$0" ] && exec env FLOCKER="$0" flock -enF "$0" "$0" "$@" || :

DATADIR={{ noaa_gefs_datadir | quote }}
WORKDIR={{ noaa_gefs_workdir | quote }}
mkdir -p "$WORKDIR" "$DATADIR"

HERE="`dirname $0`"
FETCHGEFS="$HERE/fetchGEFS_0p5.py"
CONFIGGEFS="$HERE/cdmGribReaderConfigGEFS.xml"

FIMEX_VERIF={{ metws_job_scripts | quote }}/util/fimex-verif
RT={{ metws_job_scripts | quote }}/util/rounded_times

# cleanup
AGE={{ noaa_gefs_max_age_days | quote }}
find "$WORKDIR" -maxdepth 1 -type d -name 'gefs_0p5_????????_[0-9][0-9]' -mtime "+$AGE" -exec rm -rvf \{\} \;
find "$WORKDIR" -type f -name 'gefs_0p5_????????_[0-9][0-9].grbml'       -mtime "+$AGE" -exec rm -vf \{\} \;
find "$DATADIR" -type f -name 'gefs_0p5_????????_[0-9][0-9].nc'          -mtime "+$AGE" -exec rm -vf \{\} \;
find "$DATADIR" -type f -name 'gefs_0p5_????????_[0-9][0-9]_vf.nc'       -mtime "+$AGE" -exec rm -vf \{\} \;

# fetch grib files and create grbml index file
INT={{ noaa_gefs_reftime_interval | quote }}
DLY={{ noaa_gefs_reftime_delay | quote }}
CNT={{ noaa_gefs_reftime_count | quote }}
for TIME in `"$RT" --interval "$INT" --delay "$DLY" --count "$CNT"` ; do
    if "$FETCHGEFS" \
           --retrievals "$HERE/gefs_retrievals.ini" \
           --workdir "$WORKDIR" \
           --grib-cdm-config "$CONFIGGEFS" \
           --minlon {{ noaa_gfs_gefs_minlon }} \
           --maxlon {{ noaa_gfs_gefs_maxlon }} \
           --minlat {{ noaa_gfs_gefs_minlat }} \
           --maxlat {{ noaa_gfs_gefs_maxlat }} \
           "$TIME"
    then
        :
    else
        T=`date --utc '+%Y%m%d_%H' --date "$TIME"`
        rm -vf "$WORKDIR/gefs_0p5_${T}.grbml"
        rm -rf "$WORKDIR/gefs_0p5_${T}"
    fi
done

# create netCDF-files
for i in "$WORKDIR"/gefs_0p5_????????_??.grbml; do
    NCFILE="${i/.grbml/.nc}"
    NCFILE="${DATADIR}/`basename $NCFILE`"
    if test ! -f "$NCFILE" -o "$CONFIGGEFS" -nt "$NCFILE" -o "$i" -nt "$NCFILE" ; then
        echo "creating $NCFILE"
        rm -vf "$NCFILE" "${NCFILE/.nc/_vc.nc}"
        fimex \
            --input.file="$i" \
            --input.type=grbml \
            --input.config="$CONFIGGEFS" \
            --output.file="$NCFILE" \
            --output.type=nc4
    else
        echo "$NCFILE exists, not creating new one"
    fi

    "$FIMEX_VERIF"  "$NCFILE"
done

MP={{ metws_job_scripts | quote }}/util/make_time_size_prom_file
if test -x "$MP" ; then
    FILES=()
    for TIME in `"$RT" --interval "$INT" --delay "$DLY" --count "$CNT"` ; do
        T=`date --utc '+%Y%m%d_%H' --date "$TIME"`
        FILES+=("${DATADIR}/gefs_0p5_${T}.nc")
    done

    "$MP" devcoop_noaa_gefs_0p5_latest "latest GEFS 0p5 NetCDF file" "${FILES[@]}"
fi

exit 0
